github_project/urls.py
from django.contrib import admin
from django.urls import path, include
from .views import redirect_to_url_validator

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', redirect_to_url_validator, name="url_validator"),
    path('send-mail/', include(('send_mail.urls', 'send_mail'), namespace='send_mail')),
    path('url/', include(('url_validator.urls', 'url_validator'), namespace='url_validator')),
    path('commits/', include(('recent_commits.urls', 'recent_commits'), namespace='recent_commits')),
    path('committers/', include(('top_committers.urls', 'top_committers'), namespace='top_committers')),
    path('starred-projects/', include(('starred_projects.urls', 'starred_projects'), namespace='starred_projects')),
]

recent_commits/urls.py
from django.urls import path
from .views import home_page, download_file

app_name = 'commits'
urlpatterns = [
    path('', home_page, name='commit_home_page'),
    path('download/', download_file, name='download_file'),
]

send_mail/urls.py
from django.urls import path
from .views import home_page, send_mail


app_name = 'mail'
urlpatterns = [
    path('', home_page, name='mail_home_page'),
    path('send/', send_mail, name='send_mail'),
]

starred_projects/urls.py
from django.urls import path
from .views import home_page, download_file

app_name = 'starred_projects'
urlpatterns = [
    path('', home_page, name='starred_home_page'),
    path('download/', download_file, name='download_file'),
]

top_committers/urls.py
from django.urls import path
from .views import home_page, download_file


app_name = 'committers'
urlpatterns = [
    path('', home_page, name='committers_home_page'),
    path('download/', download_file, name='download_file')
]

url_validator/urls.py
from django.urls import path
from .views import home_page


app_name = 'validator'
urlpatterns = [
    path('', home_page, name='validator_home_page'),
]

recent_commits/models.py
from django.db import models

# Create your models here.

send_mail/models.py
from django.db import models

# Create your models here.

starred_projects/models.py
from django.db import models

# Create your models here.

top_committers/models.py
from django.db import models

# Create your models here.

url_validator/models.py
from django.db import models

# Create your models here.

github_project/views.py
from django.shortcuts import HttpResponseRedirect


def redirect_to_url_validator(request):
    return HttpResponseRedirect('url/')

recent_commits/views.py
from pathlib import Path
from os.path import join
from mimetypes import guess_type
from .bin.csv_operations import CsvOperation
from .bin.github_organisation import GithubOrganisation
from django.shortcuts import render, HttpResponse, HttpResponseRedirect


# Create your views here.
def home_page(request):
    csv_op = CsvOperation()
    github = GithubOrganisation()
    github.dump_all_commits_in_csv()
    csv_op.sort_csv()
    csv_op.csv_to_json()
    return render(request, "recent_commits/index.html")


def download_file(request):
    filepath = Path(__file__).resolve().parent.parent
    filepath = join(filepath, 'github_project/json/info.json')
    filename = 'info.json'

    file = open(filepath, 'r')
    mime_type, _ = guess_type(filepath)
    response = HttpResponse(file, content_type=mime_type)
    response['Content-Disposition'] = "attachment; filename=%s" % filename

    return response

send_mail/views.py
from pathlib import Path
from os.path import join
from django.conf import settings
from django.core.mail import EmailMessage
from django.shortcuts import render, HttpResponse


# Create your views here.
BASE_DIR = join(Path(__file__).resolve().parent.parent, 'github_project')

with open(join(BASE_DIR, 'json', 'info.json'), 'r') as info_json:
    INFO_JSON = info_json.read()

with open(join(BASE_DIR, 'json', 'starred.json'), 'r') as starred_json:
    STARRED_JSON = starred_json.read()

with open(join(BASE_DIR, 'csv', 'contributors.csv'), 'r') as contributors_csv:
    CONTRIBUTORS_CSV = contributors_csv.read()


def home_page(request):
    return render(request, 'send_mail/index.html')


def send_mail(request):
    if request.method == 'POST':
        try:
            # Required details to send mail.
            subject = 'Github Organisation details.'
            message = 'Your requested details of github organisation is enclosed with this mail.'
            sender = settings.EMAIL_HOST_USER
            receiver = request.POST['email']

            # Raising exception if receiver's mail is empty.
            if receiver == '':
                raise Exception('email')

            # Sending mail with required file as an attachment with the mail.
            mail = EmailMessage(subject, message, sender, [receiver])
            mail.attach('info.json', INFO_JSON, 'file/json')
            mail.attach('starred.json', STARRED_JSON, 'file/json')
            mail.attach('contributors.json', CONTRIBUTORS_CSV, 'file/csv')
            mail.send()
            # Context for templates if mail sent successfully.
            msg = 'Mail sent!'
            color = 'green'
            button = 'Send Again'

        # Handling exception if something goes wrong while sending email.
        except Exception as e:
            if 'email' in str(e):
                msg = 'Enter your email id!'
            else:
                msg = e
            # Context for templates if error occurs.
            color = 'red'
            button = 'Try Again'

        return render(request, 'send_mail/message.html', {'message': msg, 'color': color, 'button': button})

    return render(request, 'send_mail/index.html')

starred_projects/views.py
from pathlib import Path
from os.path import join
from mimetypes import guess_type
from.bin.starred_project import StarredProject
from django.shortcuts import render, HttpResponse


# Create your views here.
BASE_DIR = Path(__file__).resolve().parent.parent
JSON_FILE = join(BASE_DIR, 'github_project', 'json', 'starred.json')


def home_page(request):
    starred_project = StarredProject()
    starred_project.dump_data_to_json()
    return render(request, 'starred_projects/index.html')


def download_file(request):
    filename = 'starred.json'
    file = open(JSON_FILE, 'r')
    mime_type, _ = guess_type(JSON_FILE)
    response = HttpResponse(file, content_type=mime_type)
    response['Content-Disposition'] = "attachment; filename=%s" % filename

    return response

top_committers/views.py
import pandas
from pathlib import Path
from os.path import join
from mimetypes import guess_type
from django.shortcuts import render, HttpResponse, HttpResponseRedirect


# Create your views here.
BASE_DIR = join(Path(__file__).resolve().parent.parent, 'github_project')
CSV_FILE = join(BASE_DIR, 'csv', 'all_commits.csv')
NEW_FILE = join(BASE_DIR, 'csv', 'contributors.csv')


def home_page(request):
    data = pandas.read_csv(CSV_FILE)
    dataframe = pandas.DataFrame(data)
    # Taking counts of commit and filtering out top 10 committers.
    top_contributors = dataframe['username'].value_counts().nlargest(10).reset_index()
    # Dumping the list of top contributors into csv file.
    top_contributors.columns = ['username', 'commit_count']
    top_contributors.to_csv(NEW_FILE, index=False)

    return render(request, 'top_committers/index.html')


def download_file(request):
    file = open(NEW_FILE, 'r')
    filename = 'contributors.csv'
    mime_type, _ = guess_type(NEW_FILE)
    response = HttpResponse(file, content_type=mime_type)
    response['Content-Disposition'] = "attachment; filename=%s" % filename

    return response

url_validator/views.py
from urllib.parse import urlparse
from .bin.validator import Validator
from django.shortcuts import render, HttpResponseRedirect


# Create your views here.
def dump_url_to_file(url: str):
    from pathlib import Path
    from os.path import join

    path = join(Path(__file__).resolve().parent.parent, 'github_project', 'bin', 'url.txt')
    # Filtering out organisation username from the url.
    if not ('http' in url):
        url = 'https://' + url

    organisation = urlparse(url).path[1:]
    # Writing url and organisation name to the file so any app can access it.
    with open(path, 'w') as file:
        file.writelines([url, '\n', organisation])


def home_page(request):
    if request.method == 'POST':
        validate = Validator()
        url = request.POST['url']
        if validate.url_validator(url):
            dump_url_to_file(url)
            return HttpResponseRedirect('../commits/')
        else:
            return render(request, 'url_validator/not_valid.html')

    return render(request, 'url_validator/index.html')

github_project/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Github Project</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
    {% block custom_css %}{% endblock %}
</head>

<body>
    <nav class="navbar bg-light">
        <div class="container-fluid">
          <span class="navbar-brand mb-0 h1">{% block navbar %}{% endblock %}</span>
        </div>
      </nav>
    {% block body %}{% endblock %}
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>
</body>
</html>

github_project/templates/recent_commits/index.html
{% extends 'base.html' %}
{% load static %}

{% block custom_css %}
    <link rel="stylesheet" href="{% static 'css/recent_commits/index.css' %}">
{% endblock %}

{% block navbar %}
    <h1>Recent Commits</h1>
{% endblock %}

{% block body %}
    <div class="container">
        <form action="download/" method="post">
            {% csrf_token %}
            <h2>Your file is ready to download!</h2>
            <div class="download">
                <button type="submit" class="btn btn-outline-primary">Download File</button>
            </div>
        </form>
        <div>
            <a href="{% url 'committers:committers_home_page' %}"><button class="link btn btn-outline-success">Top Committers</button> </a>
        </div>
    </div>

{% endblock %}

github_project/templates/send_mail/index.html
{% extends 'base.html' %}
{% load static %}


{% block custom_css %}
    <link rel="stylesheet" href="{% static 'css/send_mail/index.css' %}">
{% endblock %}

{% block navbar %}
    <h1>Send Mail</h1>
{% endblock %}

{% block body %}
    <div class="container">
        <h2>
            Enter Your E-Mail Address
        </h2>
    </div>
    <div class="container">
        <form action="send/" method="post">
            {% csrf_token %}
            <div class="input-group mb-3">
                <input name="email" type="email" class="form-control" id="email">
            </div>
            <div class="d-grid gap-2">
                <button type="submit" class="btn btn-outline-primary">Send Mail</button>
            </div>
        </form>
    </div>
{% endblock %}

github_project/templates/send_mail/message.html
{% extends 'base.html' %}
{% load static %}


{% block custom_css %}
    <link rel="stylesheet" href="{% static 'css/send_mail/index.css' %}">
{% endblock %}

{% block navbar %}
    <h1>Send Mail</h1>
{% endblock %}

{% block body %}
    <div class="container">
        <h2>
            Enter Your E-Mail Address
        </h2>
    </div>
    <div class="container">
        <form method="post" action="{% url 'mail:mail_home_page' %}">
            {% csrf_token %}
            <div class="input-group mb-3">
                <input type="email" class="form-control" id="email" disabled>
            </div>
            <div class="d-grid gap-2">
                <button type="submit" class="btn btn-outline-primary">{{ button }}</button>
            </div>
        </form>
        <div>
            <p style="color: {{ color }};" class="message">{{ message }}</p>
        </div>
    </div>
{% endblock %}

github_project/templates/starred_projects/index.html
{% extends 'base.html' %}
{% load static %}

{% block custom_css %}
    <link rel="stylesheet" href="{% static 'css/starred_projects/index.css' %}">
{% endblock %}

{% block navbar %}
    <h1>Starred Projects</h1>
{% endblock %}

{% block body %}
    <div class="container">
        <form action="download/" method="post">
            {% csrf_token %}
            <h2>Your file is ready to download!</h2>
            <div class="download">
                <button type="submit" class="btn btn-outline-primary">Download File</button>
            </div>
        </form>
        <div>
            <a href="{% url 'mail:mail_home_page' %}"><button class="link btn btn-outline-success">Send Files</button> </a>
        </div>
    </div>
{% endblock %}

github_project/templates/top_committers/index.html
{% extends 'base.html' %}
{% load static %}

{% block custom_css %}
    <link rel="stylesheet" href="{% static 'css/top_committers/index.css' %}">
{% endblock %}

{% block navbar %}
    <h1>Top 10 Committers</h1>
{% endblock %}

{% block body %}
    <div class="container">
        <form action="download/" method="post">
            {% csrf_token %}
            <h2>Your file is ready to download!</h2>
            <div class="download">
                <button type="submit" class="btn btn-outline-primary">Download File</button>
            </div>
        </form>
        <div>
            <a href="{% url 'starred_projects:starred_home_page' %}"><button class="link btn btn-outline-success">Starred Project</button> </a>
        </div>
    </div>
    
{% endblock %}

github_project/templates/url_validator/index.html
{% extends 'base.html' %}
{% load static %}


{% block custom_css %}
    <link rel="stylesheet" href="{% static 'css/url_validator/index.css' %}">
{% endblock %}

{% block navbar %}
    <h1>URL Validator</h1>
{% endblock %}

{% block body %}
    <div class="container">
        <h2>
            Enter Github Repository link
        </h2>
    </div>
    <div class="container">
        <form method="post">
            {% csrf_token %}
            <div class="input-group mb-3">
                <input name="url" type="text" class="form-control" aria-label="Sizing example input" aria-describedby="inputGroup-sizing-default">
            </div>
            <div class="submit">
                <button type="submit" class="btn btn-outline-primary">Submit</button>
            </div>
        </form>
    </div>
{% endblock %}

github_project/templates/url_validator/not_valid.html
{% extends 'base.html' %}
{% load static %}

{% block custom_css %}
    <link rel="stylesheet" href="{% static 'css/url_validator/index.css' %}">
{% endblock %}

{% block navbar %}
    <h1>URL Validator</h1>
{% endblock %}

{% block body %}
    <div class="container">
        <h2>
            Enter Github Repository link
        </h2>
    </div>
    <div class="container">
        <form method="post">
            {% csrf_token %}
            <div class="input-group mb-3">
                <input name="url" type="text" class="form-control" aria-label="Sizing example input" aria-describedby="inputGroup-sizing-default">
            </div>
            <div class="error-text">
                Enter valid GitHub URL!
            </div>
            <div class="submit">
                <button type="submit" class="btn btn-outline-primary">Submit</button>
            </div>
        </form>
    </div>
{% endblock %}